* gen_patnumbers.do
cd C:\docs\ishr
use admissions.dta, clear

* Sort by patient and date of admission, and generate observation number
sort patid admdate
generate obsno = _n
label variable obsno "Observation number"

* Give each patient a number
egen patno = group(patid)
label variable patno "Patient number"

* Generate admission number and total admissions for each patient
by patid: generate admno = _n
label variable admno "Patient's admission number"
by patid: generate admtot = _N
label variable admtot "Patient's number of admissions"

save patnumbers.dta, replace
